---
title: KeyboardLayoutMap
slug: Web/API/KeyboardLayoutMap
tags:
  - API
  - Experimental
  - Interface
  - Keyboard API
  - Keyboard Map
  - KeyboardLayoutMap
  - Reference
  - keyboard
---
<div>{{SeeCompatTable}}{{APIRef("Keyboard API")}}</div>

<p><span class="seoSummary">The <strong><code>KeyboardLayoutMap</code></strong> interface of the <a href="/docs/Web/API/Keyboard_API">Keyboard API</a> is a map-like object with functions for retrieving the string associated with specific physical keys. </span>A list of valid keys is found in the <a href="https://www.w3.org/TR/uievents-code/#key-alphanumeric-writing-system">UI Events KeyboardEvent code Values</a> specification.</p>

<h2 id="Properties">Properties</h2>

<dl>
	<dt>{{domxref('KeyboardLayoutMap.entries')}} {{readonlyinline}} {{experimental_inline}}</dt>
	<dd>Returns an array of a given object's own enumerable property <code>[key, value]</code> pairs, in the same order as that provided by a {{jsxref("Statements/for...in", "for...in")}} loop (the difference being that a <code>for-in</code> loop enumerates properties in the prototype chain as well). </dd>
	<dt>{{domxref('KeyboardLayoutMap.keys')}} {{readonlyinline}} {{experimental_inline}}</dt>
	<dd>Returns a new Array Iterator object that contains the keys for each index in the array.</dd>
	<dt>{{domxref('KeyboardLayoutMap.size')}} {{readonlyinline}} {{experimental_inline}}</dt>
	<dd>Returns the number of elements in the <code>KeyboardLayoutMap</code> object.</dd>
	<dt>{{domxref('KeyboardLayoutMap.values')}} {{readonlyinline}} {{experimental_inline}}</dt>
	<dd>Returns a new Array Iterator object that contains the values for each index in the <code>KeyboardLayoutMap</code> object.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
	<dt>{{domxref('KeyboardLayoutMap.forEach()')}} {{readonlyinline}} {{experimental_inline}}</dt>
	<dd>Executes a provided function once for each element of <code>KeyboardLayoutMap</code>.</dd>
	<dt>{{domxref('KeyboardLayoutMap.get()')}} {{experimental_inline}}</dt>
	<dd>Returns the element with the given key from the <code>KeyboardLayoutMap</code> object.</dd>
	<dt>{{domxref('KeyboardLayoutMap.has()')}} {{experimental_inline}}</dt>
	<dd>Returns a boolean indicating whether the <code>KeyboardLayoutMap</code> object has an element with the specified key.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example demonstrates how to get the location- or layout-specific string associated with the key that corresponds to the 'W' key on an English QWERTY keyboard.</p>

<pre class="brush: js">var keyboard = navigator.keyboard;
keyboard.getLayoutMap()
.then(keyboardLayoutMap =&gt; {
  var upKey = keyboardLayoutMap.get('KeyW');
  window.alert('Press ' + upKey + ' to move up.');
})</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Keyboard Map','#keyboardlayoutmap-interface','KeyboardLayoutMap')}}</td>
			<td>{{Spec2('Keyboard Map')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.KeyboardLayoutMap")}}</p>
